"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Analyze = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _createForOfIteratorHelper(o) { if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) { var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var it, normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

// function isChunkParsed(chunk) {
//   return (typeof chunk.parsedSize === 'number');
// }
function walkModules(modules = [], cb) {
  var _iterator = _createForOfIteratorHelper(modules),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      const module = _step.value;
      if (cb(module) === false) return false;

      if (module.groups) {
        if (walkModules(module.groups, cb) === false) {
          return false;
        }
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return false;
} // function elementIsOutside(elem, container) {
//   return !(elem === container || container.contains(elem));
// }


class Analyze {
  constructor(chartData) {
    this.cid = 0;
    this.allChunks = null;
    this.selectedChunks = null;
    this.cache = {
      visibleChunks: null
    };
    this.setModules(chartData);
  }

  setModules(modules) {
    walkModules(modules, module => {
      module.cid = this.cid++;
    });
    this.allChunks = modules;
    this.selectedChunks = this.allChunks;
  }

  get visibleChunks() {
    return this.allChunks;
  }

  get activeSize() {
    return 'parsedSize';
  }

} //


exports.Analyze = Analyze;